package com.zanxiang.game.module.manage.rpc.impl;

import com.zanxiang.game.module.base.pojo.enums.GameAuthEnum;
import com.zanxiang.game.module.base.pojo.vo.GameAuthUserVO;
import com.zanxiang.game.module.base.rpc.GameAuthRpc;
import com.zanxiang.game.module.manage.service.IGameAuthService;
import org.apache.dubbo.config.annotation.DubboService;
import org.springframework.beans.factory.annotation.Autowired;
import reactor.util.function.Tuple2;

import java.util.List;

/**
 * @author : lingfeng
 * @time : 2023-08-17
 * @description : 游戏授权
 */
@DubboService
public class GameAuthRpcImpl implements GameAuthRpc {

    @Autowired
    private IGameAuthService gameAuthService;

    @Override
    public GameAuthUserVO getGameAuthByUserIds(Long userId) {
        Tuple2<String, List<Long>> tuple2 = gameAuthService.getUserGameList(userId.toString());
        return GameAuthUserVO.builder()
                .userId(userId)
                .gameIdList(tuple2.getT2())
                .gameAuthEnum(GameAuthEnum.getByValue(tuple2.getT1()))
                .build();
    }
}
